'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _$traverse = require('./$traverse');

var _$traverse2 = _interopRequireDefault(_$traverse);

var _getTypeErrorMessage = require('./utils/getTypeErrorMessage');

var _getTypeErrorMessage2 = _interopRequireDefault(_getTypeErrorMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var $begin = (0, _$traverse2.default)({
  select: function select(object, next) {
    if (Array.isArray(object)) {
      return next([]);
    }
    throw new Error((0, _getTypeErrorMessage2.default)('$begin', 'array', object));
  },
  update: function update(object, next) {
    if (Array.isArray(object)) {
      var beginArray = next([]);
      if (beginArray && beginArray.length === 0) {
        return object;
      }
      if (!beginArray || typeof beginArray === 'string' || typeof beginArray.concat !== 'function') {
        return [beginArray].concat(object);
      }
      return beginArray.concat(object);
    }
    throw new Error((0, _getTypeErrorMessage2.default)('$begin', 'array', object));
  }
});

exports.default = $begin;