'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _$traverse = require('./$traverse');

var _$traverse2 = _interopRequireDefault(_$traverse);

var _getTypeErrorMessage = require('./utils/getTypeErrorMessage');

var _getTypeErrorMessage2 = _interopRequireDefault(_getTypeErrorMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var $end = (0, _$traverse2.default)({
  select: function select(object, next) {
    if (Array.isArray(object)) {
      return next([]);
    }
    throw new Error((0, _getTypeErrorMessage2.default)('$end', 'array', object));
  },
  update: function update(object, next) {
    if (Array.isArray(object)) {
      var endArray = next([]);
      if (endArray && endArray.length === 0) {
        return object;
      }
      return object.concat(endArray);
    }
    throw new Error((0, _getTypeErrorMessage2.default)('$end', 'array', object));
  }
});

exports.default = $end;