'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _copy = require('./utils/copy');

var _copy2 = _interopRequireDefault(_copy);

var _$traverse = require('./$traverse');

var _$traverse2 = _interopRequireDefault(_$traverse);

var _isNextNavigatorConstant = require('./utils/isNextNavigatorConstant');

var _isNextNavigatorConstant2 = _interopRequireDefault(_isNextNavigatorConstant);

var _$none = require('./$none');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var eachArg = function eachArg(fn, args, object) {
  for (var i = 0; i < args.length; i++) {
    var arg = args[i];
    if (Array.isArray(arg)) {
      for (var j = 0; j < arg.length; j++) {
        var subArg = arg[j];
        if (subArg in object) {
          fn(subArg);
        }
      }
    } else {
      if (arg in object) {
        fn(arg);
      }
    }
  }
};

var $pick = function $pick() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return (0, _$traverse2.default)({
    select: function select(object, next) {
      var picked = {};
      eachArg(function (key) {
        picked[key] = object[key];
      }, args, object);
      return next(picked);
    },
    update: function update(object, next, path, index) {
      // Is it worth avoiding cloning if nothing changes?
      var newObject = (0, _copy2.default)(object);
      // We cheat a little and look ahead to see if `next` is going to return
      // a constant. If it is, then there's no reason to get a proper pick of
      // the object, because we know it won't be used anyway.
      // CONSIDER THIS AN EXPERIMENT. DON'T USE IT IN YOUR NAVIGATORS.
      if ((0, _isNextNavigatorConstant2.default)(path, index)) {
        (function () {
          // Call `next` with no args, because it's a constant.
          var newPicked = next();
          if ((0, _$none.isNone)(newPicked) || newPicked == null) {
            // Delete all picked keys.
            eachArg(function (key) {
              delete newObject[key];
            });
          } else {
            if ((typeof newPicked === 'undefined' ? 'undefined' : _typeof(newPicked)) !== 'object') {
              throw new Error('$pick expected next navigator to return an object. Did you forget $each?');
            }
            // Delete any removed properties.
            eachArg(function (key) {
              if (!(key in newPicked)) {
                delete newObject[key];
              }
            }, args, object);
            // Mix in the new properties.
            (0, _objectAssign2.default)(newObject, newPicked);
          }
          // Otherwise, we do have to slice the array so it can be passed to `next`.
        })();
      } else {
        (function () {
          var pickedKeys = [];
          var picked = {};
          eachArg(function (key) {
            pickedKeys.push(key);
            picked[key] = object[key];
          }, args, object);
          var newPicked = next(picked);
          if ((0, _$none.isNone)(newPicked) || newPicked == null) {
            // Delete all picked keys
            pickedKeys.forEach(function (key) {
              delete newObject[key];
            });
          } else {
            if ((typeof newPicked === 'undefined' ? 'undefined' : _typeof(newPicked)) !== 'object') {
              throw new Error('$pick expected next navigator to return an object. Did you forget $each?');
            }
            // Delete any removed properties.
            pickedKeys.forEach(function (key) {
              if (!(key in newPicked)) {
                delete newObject[key];
              }
            });
            // Mix in the new properties.
            (0, _objectAssign2.default)(newObject, newPicked);
          }
        })();
      }
      return newObject;
    }
  });
};

exports.default = $pick;