'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _$traverse = require('./$traverse');

var _$traverse2 = _interopRequireDefault(_$traverse);

var _isNextNavigatorConstant = require('./utils/isNextNavigatorConstant');

var _isNextNavigatorConstant2 = _interopRequireDefault(_isNextNavigatorConstant);

var _getTypeErrorMessage = require('./utils/getTypeErrorMessage');

var _getTypeErrorMessage2 = _interopRequireDefault(_getTypeErrorMessage);

var _normalizeIndex = require('./utils/normalizeIndex');

var _normalizeIndex2 = _interopRequireDefault(_normalizeIndex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var $slice = function $slice(begin, end) {
  return (0, _$traverse2.default)({
    select: function select(object, next) {
      if (object && typeof object.slice === 'function') {
        var spliceBegin = (0, _normalizeIndex2.default)(begin, object.length, 0);
        var spliceEnd = (0, _normalizeIndex2.default)(end, object.length, object.length);
        return next(object.slice(spliceBegin, spliceEnd));
      }
      throw new Error((0, _getTypeErrorMessage2.default)('$slice', 'array', object));
    },
    update: function update(object, next, path, index) {
      // Is it worth avoiding cloning if nothing changes?
      if (object && typeof object.slice === 'function') {
        var newArray = object.slice(0);
        var spliceBegin = (0, _normalizeIndex2.default)(begin, object.length, 0);
        var spliceEnd = (0, _normalizeIndex2.default)(end, object.length, object.length);
        // We cheat a little and look ahead to see if `next` is going to return
        // a constant. If it is, then there's no reason to get a proper slice of
        // the array, because we know it won't be used anyway.
        // CONSIDER THIS AN EXPERIMENT. DON'T USE IT IN YOUR NAVIGATORS.
        // It actually doesn't seem to help that much unless the slice is huge.
        if ((0, _isNextNavigatorConstant2.default)(path, index)) {
          // Call `next` with no args, because it's a constant.
          var newSlice = next();
          // Splice in the new array.
          newArray.splice.apply(newArray, [spliceBegin, spliceEnd - spliceBegin].concat(_toConsumableArray(newSlice)));
          // Otherwise, we do have to slice the array so it can be passed to `next`.
        } else {
          // Create a slice.
          var slice = object.slice(spliceBegin, spliceEnd);
          // And pass it to `next`.
          var _newSlice = next(slice);
          // Splice in the new array.
          newArray.splice.apply(newArray, [spliceBegin, slice.length].concat(_toConsumableArray(_newSlice)));
        }
        return newArray;
      }
      throw new Error((0, _getTypeErrorMessage2.default)('$slice', 'array', object));
    }
  });
};

exports.default = $slice;