'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _traverse = require('./traverse');

var _$traverse = require('./$traverse');

var _reduced = require('./utils/reduced');

var _reduced2 = _interopRequireDefault(_reduced);

var _curry = require('./utils/curry');

var _$none = require('./$none');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// find is a select that returns a "reduced" envelope as soon as it selects
// anything.
var selectFirstResultFn = function selectFirstResultFn(state, result) {
  return (0, _reduced2.default)(result);
};

var find = function find(path, obj) {

  var pathIndex = 0;
  var key = void 0;

  if (!Array.isArray(path)) {
    path = [path];
  }

  // We'll just use an optimized while loop as long as we have simple primitive
  // navigators.
  while (pathIndex < path.length) {
    key = path[pathIndex];
    // If we have a non-primitive navigator, we'll switch over to a generic
    // traverse.
    if (key && typeof key !== 'string' && typeof key !== 'number' && typeof key !== 'boolean') {
      var selectResult = (0, _reduced.unreduced)((0, _traverse.traverseEach)(_$traverse.selectKey, null, selectFirstResultFn, path, obj, pathIndex));
      return (0, _$none.isNone)(selectResult) ? undefined : selectResult;
    }
    if (obj == null) {
      obj = undefined;
      break;
    }
    obj = obj[key];
    pathIndex++;
  }

  return obj;
};

exports.default = (0, _curry.curry2)(find);