'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _traverse = require('./traverse');

var _$traverse = require('./$traverse');

var _reduced = require('./utils/reduced');

var _reduced2 = _interopRequireDefault(_reduced);

var _curry = require('./utils/curry');

var _$none = require('./$none');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// has uses the same reduced envelope as find.
var selectFirstResultFn = function selectFirstResultFn(state, result) {
  return (0, _reduced2.default)(result);
};

var has = function has(path, obj) {

  var pathIndex = 0;
  var key = void 0;
  var parentObj = void 0;

  if (!Array.isArray(path)) {
    path = [path];
  }

  // We'll just use an optimized while loop as long as we have simple primitive
  // navigators.
  while (pathIndex < path.length) {
    key = path[pathIndex];
    // If we have a non-primitive navigator, we'll switch over to a generic
    // traverse.
    if (key && typeof key !== 'string' && typeof key !== 'number' && typeof key !== 'boolean') {
      var selectResult = (0, _traverse.traverseEach)(_$traverse.selectKey, null, selectFirstResultFn, path, obj, pathIndex);
      if (typeof selectResult === 'undefined') {
        return false;
      }
      selectResult = (0, _reduced.unreduced)(selectResult);
      return (0, _$none.isNone)(selectResult) ? false : true;
    }
    if (obj == null) {
      return false;
    }
    parentObj = obj;
    obj = obj[key];
    pathIndex++;
  }

  if (typeof obj === 'undefined') {
    if (path.length === 0) {
      return true;
    }
    if (!parentObj || (typeof parentObj === 'undefined' ? 'undefined' : _typeof(parentObj)) !== 'object' || !(key in parentObj)) {
      return false;
    }
  }

  return true;
};

exports.default = (0, _curry.curry2)(has);