'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _copy = require('./utils/copy');

var _copy2 = _interopRequireDefault(_copy);

var _$traverse = require('./$traverse');

var _traverse = require('./traverse');

var _curry = require('./utils/curry');

var _$none = require('./$none');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var set = function set(path, value, obj) {

  // Optimized case for a single primitive key.
  if (!path || (typeof path === 'undefined' ? 'undefined' : _typeof(path)) !== 'object') {
    if (obj == null || (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) !== 'object') {
      return obj;
    }

    if (obj[path] === value) {
      return obj;
    }

    obj = (0, _copy2.default)(obj);

    obj[path] = value;

    return obj;
  }

  path = Array.isArray(path) ? path : [path];

  return (0, _$none.undefinedIfNone)((0, _traverse.traverseEach)(_$traverse.updateKey, undefined, undefined, path, obj, 0, function () {
    return value;
  }));
};

exports.default = (0, _curry.curry3)(set);