'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _copy = require('./copy');

var _copy2 = _interopRequireDefault(_copy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createMerge = function createMerge() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$isDeep = _ref.isDeep,
      isDeep = _ref$isDeep === undefined ? false : _ref$isDeep;

  var isShallow = !isDeep;
  var merge = function merge(spec, object) {
    if (spec && (typeof spec === 'undefined' ? 'undefined' : _typeof(spec)) === 'object' && object && (typeof object === 'undefined' ? 'undefined' : _typeof(object)) === 'object') {
      var newObject = object;
      for (var key in spec) {
        if (spec.hasOwnProperty(key)) {
          var mergeValue = isShallow ? spec[key] : merge(spec[key], object[key]);
          if (newObject[key] !== mergeValue) {
            // Create a new object if we haven't done that yet.
            if (newObject === object) {
              newObject = (0, _copy2.default)(object);
            }
            newObject[key] = mergeValue;
          }
        }
      }
      return newObject;
    }
    return spec;
  };
  return merge;
};

exports.default = createMerge;