'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var pluralize = function pluralize(type) {
  return type + 's';
};

var typeName = function typeName(object) {
  if (object === null) {
    return 'null';
  }
  if (Array.isArray(object)) {
    return 'array';
  }
  return typeof object === 'undefined' ? 'undefined' : _typeof(object);
};

// Prepend word with "a" or "an".
var articleize = function articleize(type) {
  return ('aeiou'.indexOf(type[0]) >= 0 ? 'an' : 'a') + ' ' + type;
};

// Concatenate types together into a phrase.
var getSupportedTypesPhrase = function getSupportedTypesPhrase(supportedTypes) {
  supportedTypes = Array.isArray(supportedTypes) ? supportedTypes : [supportedTypes];
  var pluralTypes = supportedTypes.map(function (type) {
    return pluralize(type);
  });

  if (pluralTypes.length === 1) {
    return pluralTypes[0];
  }

  if (pluralTypes.length === 2) {
    return pluralTypes[0] + ' and ' + pluralTypes[1];
  }

  return pluralTypes.slice(0, pluralTypes.length - 1).join(', ').concat(', and ' + pluralTypes[pluralTypes.length - 1]);
};

// Get error message saying what types a function supports.
var getTypeErrorMessage = function getTypeErrorMessage(name, supportedTypes, object) {
  return [name, ' only supports ', getSupportedTypesPhrase(supportedTypes), ', but ', articleize(typeName(object)), ' was provided.'].join('');
};

exports.default = getTypeErrorMessage;