'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _$none = require('../$none');

var _$set = require('../$set');

// Special purpose utility to look at the current path and index and determine
// if the next navigator is a constant value. This is so a navigator can
// "cheat" a little and lookahead to determine if its value will actually be
// used. If not, the navigator can avoid calculating its own value.
exports.default = function (path, index) {
  if (index + 1 < path.length) {
    var nextNav = path[index + 1];
    if (nextNav) {
      var navKey = nextNav['@@qim/nav'];
      if (navKey === _$none.$noneKey || navKey === _$set.$setKey) {
        return true;
      }
    }
  }
  return false;
};