'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _reduced = require('./reduced');

var _getTypeErrorMessage = require('./getTypeErrorMessage');

var _getTypeErrorMessage2 = _interopRequireDefault(_getTypeErrorMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reduceSequence = function reduceSequence(eachFn, initialValue, seq) {
  var result = initialValue;
  if (Array.isArray(seq)) {
    for (var i = 0; i < seq.length; i++) {
      result = eachFn(result, i);
      if ((0, _reduced.isReduced)(result)) {
        return result;
      }
    }
  } else if (seq !== null && (typeof seq === 'undefined' ? 'undefined' : _typeof(seq)) === 'object') {
    for (var key in seq) {
      if (seq.hasOwnProperty(key)) {
        result = eachFn(result, key);
        if ((0, _reduced.isReduced)(result)) {
          return result;
        }
      }
    }
  } else {
    throw new Error((0, _getTypeErrorMessage2.default)('reduceSequence', ['object', 'array'], seq));
  }
  return result;
};

exports.default = reduceSequence;