'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// There's not really any compatibility between `qim` and transducers, but since
// transducers already had a "reduced" concept, it seemed appropriate to use
// that convention.

// When looping through object or array values, `reduced` is used to tell the
// loop that the loop is finished.
var reduced = function reduced(value) {
  return {
    '@@transducer/reduced': true,
    '@@transducer/value': value
  };
};

exports.default = reduced;
var isReduced = exports.isReduced = function isReduced(value) {
  return value && !!value['@@transducer/reduced'];
};

// Unwrap a reduced value if necessary.
var unreduced = exports.unreduced = function unreduced(value) {
  return isReduced(value) ? value['@@transducer/value'] : value;
};