'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// When an item is removed from an array or object, `removed` is used to mark
// it as being removed. This is useful, for example, so that we can remove an
// item inside a loop without affecting the affecting the item count. We could
// use $none for this, but `removed` specifically exists to allow you to store
// $none in an array/object and still have `qim` work correctly. So what if you
// want to store `removed` in your array/object? That's just silly. :-P
var removed = {
  '@@qim/removed': true
};

exports.default = removed;
var isRemoved = exports.isRemoved = function isRemoved(value) {
  return value && value['@@qim/removed'];
};

var isNotRemoved = exports.isNotRemoved = function isNotRemoved(value) {
  return !value || !value['@@qim/removed'];
};